<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: shared_ptr_thread_safe_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_8046d21543c5bdd4721c6d619be3c6b2.html">smart_pointers</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">shared_ptr_thread_safe_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2007  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_SHARED_PTr_THREAD_SAFE_ABSTRACT_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_SHARED_PTr_THREAD_SAFE_ABSTRACT_ </span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;exception&gt;</span>     </div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a> </div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;{</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        &gt; </div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <span class="keyword">class </span>shared_ptr_thread_safe </div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    {</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        <span class="keyword">typedef</span> T element_type;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160; </div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        shared_ptr_thread_safe(</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        );</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y&gt; </div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        <span class="keyword">explicit</span> shared_ptr_thread_safe(</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;            Y* p</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        );</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y, <span class="keyword">typename</span> D&gt; </div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        shared_ptr_thread_safe(</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            Y* p, </div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            <span class="keyword">const</span> D&amp; d</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        );</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        shared_ptr_thread_safe( </div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;            <span class="keyword">const</span> shared_ptr_thread_safe&amp; r</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        );</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y&gt; </div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        shared_ptr_thread_safe(</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;            <span class="keyword">const</span> shared_ptr_thread_safe&lt;Y&gt;&amp; r</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;        );</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y&gt;</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;        <span class="keyword">explicit</span> shared_ptr_thread_safe(</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;            std::auto_ptr&lt;Y&gt;&amp; r</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        );</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        ~shared_ptr_thread_safe(</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        );</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        shared_ptr_thread_safe&amp; operator= (</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;            <span class="keyword">const</span> shared_ptr_thread_safe&amp; r</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        );</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y&gt; </div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        shared_ptr_thread_safe&amp; operator= (</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;            <span class="keyword">const</span> shared_ptr_thread_safe&lt;Y&gt;&amp; r</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;        );</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y&gt; </div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        shared_ptr_thread_safe&amp; operator= (</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;            std::auto_ptr&lt;Y&gt;&amp; r</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        );</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        <span class="keywordtype">void</span> reset(</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        );</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y&gt; </div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        <span class="keywordtype">void</span> reset(</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;            Y* p</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;        );</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;        <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Y, <span class="keyword">typename</span> D&gt; </div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        <span class="keywordtype">void</span> reset(</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;            Y* p, </div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;            <span class="keyword">const</span> D&amp; d</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;        );</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        T* get(</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        ) <span class="keyword">const</span>; </div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;        T&amp; operator*(</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;        ) <span class="keyword">const</span>; </div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;        T* operator-&gt;(</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;        ) <span class="keyword">const</span>; </div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        <span class="keywordtype">bool</span> unique(</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        <span class="keywordtype">long</span> use_count(</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;        <span class="keyword">operator</span> bool(</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;        <span class="keywordtype">void</span> swap(</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;            shared_ptr_thread_safe&amp; b</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        );</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;    };</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160; </div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160; </div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;    <span class="keywordtype">bool</span> operator== (</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;        <span class="keyword">const</span> shared_ptr_thread_safe&lt;T&gt;&amp; a, </div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;        <span class="keyword">const</span> shared_ptr_thread_safe&lt;U&gt;&amp; b</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;    );</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;    <span class="keywordtype">bool</span> operator!= (</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;        <span class="keyword">const</span> shared_ptr_thread_safe&lt;T&gt;&amp; a, </div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;        <span class="keyword">const</span> shared_ptr_thread_safe&lt;U&gt;&amp; b</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;    ) { <span class="keywordflow">return</span> a.get() != b.get(); }</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;    <span class="keywordtype">bool</span> operator&lt; (</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;        <span class="keyword">const</span> shared_ptr_thread_safe&lt;T&gt;&amp; a, </div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;        <span class="keyword">const</span> shared_ptr_thread_safe&lt;U&gt;&amp; b</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;    );</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; </div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;    <span class="keywordtype">void</span> swap(</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;        shared_ptr_thread_safe&lt;T&gt;&amp; a, </div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;        shared_ptr_thread_safe&lt;T&gt;&amp; b</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;    ) { a.swap(b); }</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;    shared_ptr_thread_safe&lt;T&gt; static_pointer_cast(</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;        <span class="keyword">const</span> shared_ptr_thread_safe&lt;U&gt;&amp; r</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;    );</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;    shared_ptr_thread_safe&lt;T&gt; const_pointer_cast(</div><div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;        <span class="keyword">const</span> shared_ptr_thread_safe&lt;U&gt;&amp; r</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;    );</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;    shared_ptr_thread_safe&lt;T&gt; dynamic_pointer_cast(</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;        <span class="keyword">const</span> shared_ptr_thread_safe&lt;U&gt;&amp; r</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;    );</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> E, <span class="keyword">typename</span> T, <span class="keyword">typename</span> Y&gt;</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;    std::basic_ostream&lt;E, T&gt; &amp; operator&lt;&lt; (</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;        std::basic_ostream&lt;E, T&gt; &amp; os, </div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;        <span class="keyword">const</span> shared_ptr_thread_safe&lt;Y&gt;&amp; p</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;    );</div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> D, <span class="keyword">typename</span> T&gt;</div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;    D* get_deleter(</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;        <span class="keyword">const</span> shared_ptr_thread_safe&lt;T&gt;&amp; p</div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;    );</div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160; </div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;}</div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160; </div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;<span class="preprocessor">#endif // DLIB_SHARED_PTr_THREAD_SAFE_ABSTRACT_</span></div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
